Attribute VB_Name = "modMMC"
Option Explicit

'API declarations
Public Declare Sub RtlMoveMemory Lib "kernel32" (Destination As Any, source As Any, ByVal Length As Long)
Public Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Public Declare Function GetLastError Lib "kernel32" () As Long
Public Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long
Public Declare Function LoadLibraryA Lib "kernel32" (ByVal lpLibFileName As String) As Long
Public Declare Sub SetLastError Lib "kernel32" (ByVal dwErrCode As Long)

'public constants
Public Const ERR_SRC       As String = "cCDECL"    'Error source name
Public Const ERR_NUM       As Long = vbObjectError 'cCDECL error number base
Public Const MAX_ARG       As Long = 16            'Maximum number of parameters, you can change this if required
Public Const PATCH_01      As Long = 15            'CDECL patch, CDECL function address


Public Const CODE_CDECL    As String = "538B5C240C8B0BE305FF348BE2FBE8<fix 01>8B0BC1E10201CC5B8B54240C890231C0C20C00"
Public Const CODE_WRAPPER  As String = "E8000000005A8F4219E8<fix 02>81EC<fix 03>E8000000005AFF7205C300000000"


Private Declare Function DeviceIoControl Lib "kernel32" (ByVal hDevice As Long, ByVal dwIoControlCode As _
    Long, ByRef lpInBuffer As Any, ByVal nInBufferSize As Long, ByRef lpOutBuffer As Any, ByVal _
    nOutBufferSize As Long, ByRef lpBytesReturned As Long, lpOverlapped As Any) As Long
Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal _
    dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal _
    dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" (ByVal nDrive As String) As Long
Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As _
    OSVERSIONINFOEX) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, source As Any, _
    ByVal Length As Long)
Private Declare Sub ZeroMemory Lib "kernel32.dll" Alias "RtlZeroMemory" (Destination As Any, ByVal Length _
    As Long)
Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMS As Long) As _
    Long
Private Declare Function CreateEvent Lib "kernel32" Alias "CreateEventA" (ByVal lpEventAttributes As Long, _
    ByVal bManualReset As Long, ByVal bInitialState As Long, ByVal lpname As String) As Long
Private Declare Function ResetEvent Lib "kernel32" (ByVal hEvent As Long) As Long
Private Declare Sub Sleep Lib "kernel32" (ByVal ms As Long)

Private Type OSVERSIONINFOEX
    dwOSVersionInfoSize             As Long
    dwMajorVersion                  As Long
    dwMinorVersion                  As Long
    dwBuildNumber                   As Long
    dwPlatformId                    As Long
    szCSDVersion                    As String * 128
End Type

Private Type SPTD
    Length                          As Integer
    ScsiStatus                      As Byte
    PathId                          As Byte
    TargetID                        As Byte
    LUN                             As Byte
    CdbLength                       As Byte
    SenseInfoLength                 As Byte
    DataIn                          As Byte
    DataTransferLength              As Long
    TimeOutValue                    As Long
    DataBuffer                      As Long
    SenseInfoOffset                 As Long
    cdb(15)                         As Byte
    Fill(2)                         As Byte
End Type

Private Type SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER
    SPT                             As SPTD
    'Fill(3)                         As Byte
    SenseBuffer(35)                 As Byte
End Type

Private Type SRB
    SRB_Cmd             As Byte            ' ASPI Befehl
    SRB_Status          As Byte            ' Befehlsstatus
    SRB_HAID            As Byte            ' Host Adapter
    SRB_Flags           As Byte            ' Ausfhrungsflags
    SRB_Hdr_Rsvd        As Long            ' reserviert
End Type

Private Type SRB_GetDevType
    SRB_Hdr             As SRB             ' ASPI Befehlsheader
    SRB_Target          As Byte            ' Target
    SRB_LUN             As Byte            ' Target Logical Unit Number
    DEV_DeviceType      As Byte            ' Gertetyp
    DEV_Rsvd1           As Byte            ' reserviert
    DEV_Pad(67)         As Byte            ' padding Bytes
End Type

Private Enum SRB_Command
    SC_HA_INQUIRY = &H0                   ' Host Adapter Info
    SC_GET_DEV_TYPE = &H1                 ' Informationen ber SCSI Gerte
    SC_EXEC_SCSI_CMD = &H2                ' SCSI I/O
    SC_ABORT_SRB = &H3                    ' Einen noch ausstehenden I/O Request abbrechen
    SC_RESET_DEV = &H4                    ' SCSI Target zurcksetzen
    SC_SET_HA_PARMS = &H5                 ' HA Parameter setzen
    SC_GET_DISK_INFO = &H6                ' Informationen zu Typ:Disk Laufwerken (Win 9x/Me)
    SC_RESCAN_SCSI_BUS = &H7              ' SCSI Bus absuchen
    SC_GETSET_TIMEOUTS = &H8              ' Timeouts setzen fr SRBs
End Enum

Private Type SRB_ExecuteIO
    SRB_Hdr             As SRB            ' ASPI Befehlsheader
    SRB_Target          As Byte           ' Target
    SRB_LUN             As Byte           ' Target Logical Unit Number
    SRB_Rsvd1           As Integer        ' reserviert
    SRB_BufLen          As Long           ' Datenzuweisungslnge
    SRB_BufPointer      As Long           ' Pointer zum Datenpuffer
    SRB_SenseLen        As Byte           ' Sense Lnge
    SRB_CDBLen          As Byte           ' CDB Lnge
    SRB_HaStat          As Byte           ' Host Adapter Status
    SRB_TargStat        As Byte           ' Target Status
    SRB_PostProc        As Long           ' Post Methode
    SRB_Rsvd2(19)       As Byte           ' reserviert
    SRB_CDBByte(15)     As Byte           ' SCSI CDB
    SRB_SenseData(15)   As Byte           ' Sense Buffer
End Type

Private Type SRB_GetSetTimeouts
    SRB_Hdr             As SRB
    SRB_Target          As Byte
    SRB_LUN             As Byte
    SRB_Timeout         As Long
End Type

Private Enum SRB_Status
    SS_PENDING = &H0
    SS_COMP = &H1
    SS_ABORTED = &H2
End Enum

Private Enum SRB_Flags
    SRB_DIR_IN = &H8
    SRB_DIR_OUT = &H10
End Enum

Private Enum DevTypes
    DTYPE_CDROM = 5             ' CD/DVD-ROM
End Enum

Public Enum OpCodes
    OP_TEST_UNIT_READY = &H0
    OP_INQUIRY = &H12
    OP_GET_EVENT_STATUS_NOTIFICATION = &H4A
    OP_MODE_SENSE10 = &H5A
End Enum

Public Enum DataDirection
    DIR_IN
    DIR_OUT
End Enum

Public Enum Status
    STATUS_RESERV_CONF = &H18
    STATUS_GOOD = &H0
    STATUS_TIMEOUT = &HFF
End Enum

Public Type page_header
    datalen(1)                      As Byte
    rsvd(3)                         As Byte
    blockdescriptor(1)              As Byte
End Type

Private Type page_capabilities
    hdr                             As page_header
    pagecode                        As Byte
    pagelen                         As Byte
    readcaps                        As Byte
    writecaps                       As Byte
    audiomsess                      As Byte
    audiosubs                       As Byte
    mechanism                       As Byte
    mechpw                          As Byte
    maxreadspeed(1)                 As Byte
    vollevels(1)                    As Byte
    buffersize(1)                   As Byte
    currreadspeed(1)                As Byte
    rsvd3                           As Byte
    BCKF                            As Byte
    maxwritespeed(1)                As Byte
    currwritespeedobs(1)            As Byte ' MMC-1/2
    cpymngmt(1)                     As Byte
    rsvd6                           As Byte
    rsvd7                           As Byte
    rotctrl                         As Byte
    currwritespeed(1)               As Byte ' MMC-3
End Type

Public Type inquiry
    qualifier       As Byte
    rsvd1           As Byte
    version         As Byte
    respfmt         As Byte
    addlen          As Byte
    rsvd2           As Byte
    stuff(1)        As Byte
    vendor(7)       As Byte
    product(15)     As Byte
    revision(3)     As Byte
    rsvd3(1)        As Byte
    stuff2(37)      As Byte
End Type

Private Type t_HAID
    HA                  As Byte
    ID                  As Byte
    LUN                 As Byte
End Type
Private Type t_SCSI_ADDRESS
    Length              As Long
    PortNumber          As Byte
    PathId              As Byte
    TargetID            As Byte
    LUN                 As Byte
End Type

Private Type SRB_GetDiskInfo
    SRB_Hdr             As SRB            ' ASPI Befehlsheader
    SRB_Target          As Byte           ' Target
    SRB_LUN             As Byte           ' Target Logical Unit Number
    SRB_DriveFlags      As Byte           ' Laufwerksflags
    SRB_Int13DrvInfo    As Byte           ' + 65 = Laufwerksbuchstabe
    SRB_Heads           As Byte           ' Kpfe
    SRB_Sectors         As Byte           ' Sektoren
    SRB_Rsvd1(9)        As Byte           ' reserviert
End Type

Private Enum SPTIDirection
    SCSI_IOCTL_DATA_OUT = 0
    SCSI_IOCTL_DATA_IN = 1
    SCSI_IOCTL_DATA_UNSPECIFIED = 2
End Enum

Private Const SENSE_LEN As Long = 14&
Private Const MAX_SRB_TIMEOUT As Long = 108000
Private Const FNC_INFO  As String = "GetASPI32SupportInfo"
Private Const FNC_CMD   As String = "SendASPI32Command"
Private Const IOCTL_SCSI_GET_ADDRESS As Long = &H41018
Private Const IOCTL_SCSI_BASE       As Long = &H4
Private Const METHOD_BUFFERED       As Long = &H0
Private Const FILE_READ_ACCESS      As Long = &H1
Private Const FILE_WRITE_ACCESS     As Long = &H2
Private Const OPEN_EXISTING         As Long = &H3
Private Const GENERIC_READ          As Long = &H80000000
Private Const GENERIC_WRITE         As Long = &H40000000
Private Const FILE_SHARE_READ       As Long = &H1
Private Const FILE_SHARE_WRITE      As Long = &H2
Private Const FILE_ATTRIBUTE_NORMAL As Long = &H80
Private Const VER_PLATFORM_WIN32_NT As Long = &H2
Private Const WAIT_TIMEOUT          As Long = &H102&

Private IOCTL_SCSI_PASS_THROUGH_DIRECT As Long
Private Installed                   As Boolean
Private Initialized                 As Boolean
Private blnASPIInst                 As Boolean
Private lngPower2(31)               As Long
Private lngHandles(25)              As Long
Private btLastSK                    As Byte
Private btLastASC                   As Byte
Private btLastASCQ                  As Byte
Private ASPILib                     As clsCDECL
Private colDrives                   As Collection
Private drvid                       As String
Private drvhandle                   As String
Private ASPI                        As Boolean
Private SPTI                        As Boolean



Public Type tParamBlock
  ParamCount                As Long                 'Number of parameters to be forwarded to the cdecl function
  Params(0 To MAX_ARG - 1)  As Long                 'Array of parameters to be forwarded to the cdecl function
End Type

'Private variables
Private bNewDLL             As Boolean              'Flag to indicate that the loaded DLL has changed
Public pMe                 As Long                 'vtable address
Private hMod                As Long                 'DLL module handle
Private nAddr               As Long                 'Cache the previous cdecl function's address
Private nEntry              As Long                 'vtable entry index
Public pCode               As Long                 'Pointer to the CDECL code
Private sLastFunc           As String               'Cache the previous cdecl function's name
Public sCode()             As String               'Code buffer string array...
Private pb                  As tParamBlock          'Parameter block instance


Public Sub loadSPTI()
Dim page As page_capabilities
    
    drvid = frmMain.Text1.Text

    Dim handle  As Long
    Installed = GetDriveHandleSPTI(handle)

    If Installed Then  'STPI erfolgreich => anwenden
        ASPI = False
        SPTI = True
        
        'SPTD Control Code
        IOCTL_SCSI_PASS_THROUGH_DIRECT = CTL_CODE(IOCTL_SCSI_BASE, &H405, METHOD_BUFFERED, _
            FILE_READ_ACCESS Or FILE_WRITE_ACCESS)

        If CDModeSense10(&H2A, VarPtr(page), Len(page)) <> STATUS_GOOD Then
            MsgBox "Konnte Mode Page 2Ah nicht lesen.", vbExclamation
            Exit Sub
        End If
        
        If LoadingMech(SHR(page.mechanism, 5)) = "Tray" Then
            frmMain.Label4.Caption = False
            frmMain.Label1.Caption = SPTITrayOpen()
        Else
            MsgBox "CD/DVD Laufwerk besitzt kein Tray!", vbExclamation
            Unload frmMain
        End If

    Else
        MsgBox "SPTI schlgt fehl, versuche ASPI!", vbExclamation
        Set ASPILib = New clsCDECL
        blnASPIInst = DllLoad("WNASPI32.DLL")
        Installed = blnASPIInst
        Initialized = HiByte(LoWord(CallFunc(FNC_INFO))) = SS_COMP
        Call FindDrivesASPI

        If Installed And Initialized Then 'ASPI erfolgreich => anwenden
            ASPI = True
            SPTI = False
            frmMain.Label4.Caption = True
            Call ASPITrayOpen
        Else
            MsgBox "Kein funktionierendes Interface gefunden!", vbExclamation
            Unload frmMain
        End If
    End If
End Sub
Public Sub loadASPI()
Dim page As page_capabilities
Dim i As Long
drvid = frmMain.Text1.Text

    Set ASPILib = New clsCDECL
    blnASPIInst = DllLoad("WNASPI32.DLL")
    Installed = blnASPIInst
    Initialized = HiByte(LoWord(CallFunc(FNC_INFO))) = SS_COMP
    Call FindDrivesASPI

    If Installed And Initialized Then 'ASPI erfolgreich => anwenden
        ASPI = True
        SPTI = False
        For i = 1 To colDrives.Count
            If UCase(frmMain.Text1.Text) = DriveCharASPI(colDrives.Item(i)) Then
                drvhandle = colDrives.Item(i)
            End If
        Next
        If CDModeSense10(&H2A, VarPtr(page), Len(page)) <> STATUS_GOOD Then
            MsgBox "Konnte Mode Page 2Ah nicht lesen.", vbExclamation
            Exit Sub
        End If

        If LoadingMech(SHR(page.mechanism, 5)) = "Tray" Then
            frmMain.Label4.Caption = True
            Call ASPITrayOpen
        Else
            MsgBox "CD/DVD Laufwerk besitzt kein Tray!", vbExclamation
            Unload frmMain
        End If
    Else
        MsgBox "ASPI schlgt fehl, versuche SPTI!", vbExclamation
        Dim handle  As Long
        Installed = GetDriveHandleSPTI(handle)
        If Installed Then  'STPI erfolgreich => anwenden
            ASPI = False
            SPTI = True
            frmMain.Label4.Caption = False
            frmMain.Label1.Caption = SPTITrayOpen()
        Else
            MsgBox "Kein funktionierendes Interface gefunden!", vbExclamation
            Unload frmMain
        End If
    End If
End Sub
Public Sub ASPITrayOpen()
    Dim buffer      As inquiry  ' Datenpuffer
    Dim i           As Integer
         
    ' INQUIRY ausfhren
    Dim cdb(5)  As Byte
    cdb(0) = OP_INQUIRY     ' Inquiry OpCode
    cdb(4) = Len(buffer)    ' Datenzuweisungslnge

    If ExecCMDASPI(cdb, 6, DIR_IN, VarPtr(buffer), Len(buffer)) <> STATUS_GOOD Then
        MsgBox "INQUIRY fr Laufwerk " & drvhandle & " gescheitert.", vbExclamation
        Exit Sub
    End If
    
    'Laufwerk offen?
    frmMain.Label1.Caption = IsTrayOpenASPI()
       
    DllUnload
End Sub

Public Function IsTrayOpenASPI() As Boolean
    Dim btEvent(8)  As Byte

    If Not CDTestUnitReady() = STATUS_GOOD Then
        If btLastASC = &H3A And btLastASCQ = &H1 Then
            Exit Function
        ElseIf btLastASC = &H3A And btLastASCQ = &H2 Then
            IsTrayOpenASPI = True
            Exit Function
        End If
    End If

    If CDGetEventStatusNotification(&H10, VarPtr(btEvent(0)), UBound(btEvent) + 1) = STATUS_GOOD Then
        IsTrayOpenASPI = Abs(IsBitSet(btEvent(5), 0))
    End If
End Function

Public Function GetDriveHandleASPI(ByVal drv As String, ByRef fh As Long) As Boolean
    Dim flags   As Long

    flags = GENERIC_READ
    If IsNT_2K_XP Then flags = flags Or GENERIC_WRITE

    fh = CreateFile("\\.\" & Left$(drv, 1) & ":", flags, _
                    FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0, _
                    OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, ByVal 0)

    GetDriveHandleASPI = fh <> -1
End Function
Private Function DriveCharWin9xASPI(ByVal HA As Byte, ByVal ID As Byte, ByVal LUN As Byte) As String
    Dim diskinfo As SRB_GetDiskInfo

    diskinfo.SRB_Hdr.SRB_Cmd = SC_GET_DISK_INFO
    diskinfo.SRB_Hdr.SRB_Flags = SRB_DIR_IN
    diskinfo.SRB_Hdr.SRB_HAID = HA
    diskinfo.SRB_Target = ID
    diskinfo.SRB_LUN = LUN

    SRBDiskInfo diskinfo

    ' Laufwerksbuchstabe zurckgeben
    DriveCharWin9xASPI = Chr$(diskinfo.SRB_Int13DrvInfo + 65)

End Function

Private Function DriveCharWinNTASPI(ByVal HA As Byte, ByVal ID As Byte, ByVal LUN As Byte) As String
    Dim haid    As t_HAID
    Dim i       As Long, strDrv As String

    'go through all 26 possible drives
    For i = 1 To 26
        'CD-ROM?
        If GetDriveType(Chr(i + 64) & ":") = DTYPE_CDROM Then
            strDrv = Chr(i + 64)
            'compare to the parameters
            If NTGetHAID(strDrv, haid) Then
                If haid.HA = HA And haid.ID = ID And haid.LUN = LUN Then
                    'found it!
                    DriveCharWinNTASPI = Chr$(i + 64)
                End If
            End If
        End If
    Next
End Function

Private Function NTGetHAID(strDrv As String, ByRef haid As t_HAID) As Boolean
    Dim returned    As Long, Status As Long
    Dim fh          As Long
    Dim pscsiAddr   As t_SCSI_ADDRESS

    'get drive handle
    If GetDriveHandleASPI(Left$(strDrv, 1), fh) Then

        'get SCSI address
        pscsiAddr.Length = Len(pscsiAddr)
        Status = DeviceIoControl(fh, IOCTL_SCSI_GET_ADDRESS, pscsiAddr, Len(pscsiAddr), pscsiAddr, Len(pscsiAddr), returned, ByVal 0&)
        CloseHandle fh

        'success?
        If Status = 1 Then
                haid.HA = pscsiAddr.PathId
                haid.ID = pscsiAddr.TargetID
                haid.LUN = pscsiAddr.LUN
                NTGetHAID = True
                Exit Function
        End If
    End If
End Function

Private Function DriveCharASPI(handle As String) As Variant
    Dim btHA As Byte, btID As Byte, btLUN As Byte

    btHA = Asc(Mid$(handle, 1, 1))
    btID = Asc(Mid$(handle, 2, 1))
    btLUN = Asc(Mid$(handle, 3, 1))

    If IsNT_2K_XP Then
        DriveCharASPI = DriveCharWinNTASPI(btHA, btID, btLUN)
    Else
        DriveCharASPI = DriveCharWin9xASPI(btHA, btID, btLUN)
    End If
End Function

Public Sub FindDrivesASPI()
    Dim HACnt As Integer, IDCnt As Integer, LUNCnt As Integer
    Dim DevTyp  As SRB_GetDevType
    Set colDrives = New Collection

    ' Host Adapters
    HACnt = LoByte(LoWord(CallFunc(FNC_INFO)))

    ' jeden Bus abklappern
    For HACnt = 0 To HACnt
        ' jede SCSI ID durchgehen
        For IDCnt = 0 To 7
            ' alle Logical Unit Numbers berprfen
            For LUNCnt = 0 To 7
                ' GetDeviceType aufrufen, um Gertetyp zu berprfen
                ZeroMemory DevTyp, LenB(DevTyp)
                DevTyp.SRB_Hdr.SRB_Cmd = SC_GET_DEV_TYPE
                DevTyp.SRB_Hdr.SRB_HAID = HACnt
                DevTyp.SRB_Target = IDCnt
                DevTyp.SRB_LUN = LUNCnt
                SRBGetDev DevTyp

                If DevTyp.SRB_Hdr.SRB_Status = SS_COMP Then
                    If DevTyp.DEV_DeviceType = DTYPE_CDROM Then
                        colDrives.Add Chr$(HACnt) & Chr$(IDCnt) & Chr$(LUNCnt)
                    End If
                End If
            Next
        Next
    Next
End Sub

Public Function ExecCMDASPI(cdb() As Byte, CDBLen As Byte, direction As DataDirection, ByVal buffer As _
    Long, ByVal bufferlen As Long, Optional timeout As Integer = 5) As Status

    Dim SRB_Exec    As SRB_ExecuteIO
    Dim SRB_Timeout As SRB_GetSetTimeouts
    Dim blnTimeout  As Boolean
    Dim hEvent As Long, lngRet As Long
    Dim btHA As Byte, btID As Byte, btLUN As Byte

    ' Bus Adresse
    btHA = Asc(Mid$(drvhandle, 1, 1))
    btID = Asc(Mid$(drvhandle, 2, 1))
   btLUN = Asc(Mid$(drvhandle, 3, 1))

    ' Event fr Fortschrittsinfo erstellen
    hEvent = CreateEvent(0, 1, 0, 0)
    ResetEvent hEvent

    With SRB_Exec
        .SRB_Hdr.SRB_Cmd = SC_EXEC_SCSI_CMD
        .SRB_PostProc = hEvent
        .SRB_Hdr.SRB_HAID = btHA
        .SRB_Target = btID
        .SRB_LUN = btLUN
        .SRB_BufPointer = buffer
        .SRB_BufLen = bufferlen
        .SRB_SenseLen = SENSE_LEN

        ' DIR_IN = Daten in Puffer empfangen
        ' DIR_OUT = Puffer senden
        If direction = DIR_IN Then
            .SRB_Hdr.SRB_Flags = SRB_DIR_IN
        Else
            .SRB_Hdr.SRB_Flags = SRB_DIR_OUT
        End If

        .SRB_CDBLen = CDBLen
        CopyMemory .SRB_CDBByte(0), cdb(0), CDBLen
    End With

    ' Versuchen, Timeout fr Bus Adresse zu setzen
    With SRB_Timeout
        .SRB_Hdr.SRB_Cmd = SC_GETSET_TIMEOUTS
        .SRB_Hdr.SRB_Flags = SRB_DIR_OUT
        .SRB_Hdr.SRB_HAID = btHA
        .SRB_Target = btID
        .SRB_LUN = btLUN
        If timeout = 0 Then
            .SRB_Timeout = MAX_SRB_TIMEOUT
        Else
            .SRB_Timeout = timeout * 2
        End If
    End With

    SRBSetTimeout SRB_Timeout
    blnTimeout = SRB_Timeout.SRB_Hdr.SRB_Status = SS_COMP

    SRBExec SRB_Exec

    ' Wenn SC_GETSET_TIMEOUTS nicht geklappt hat
    If Not blnTimeout Then
        ' fr immer auf Ende warten?
        If timeout = 0 Then
            Do While SRB_Exec.SRB_Hdr.SRB_Status = SS_PENDING
                DoEvents
            Loop
        Else
            ' fr bestimmte Zeit auf Ende warten
            Sleep 30
            If SRB_Exec.SRB_Hdr.SRB_Status = SS_PENDING Then
                lngRet = WaitForSingleObject(hEvent, timeout * 1000)
            End If
        End If
    ' SC_GETSET_TIMEOUTS hat geklappt
    Else
        Do While SRB_Exec.SRB_Hdr.SRB_Status = SS_PENDING
            DoEvents
        Loop
    End If

    ' fr den Fall, das SC_GETSET_TIMEOUTS gegeklappt hat
    If blnTimeout Then
        If SRB_Exec.SRB_Hdr.SRB_Status = SS_ABORTED Then
            ExecCMDASPI = STATUS_TIMEOUT
        Else
            ExecCMDASPI = SRB_Exec.SRB_TargStat
        End If
    ' SC_GETSET_TIMEOUTS wollte nicht...
    Else
        If lngRet = WAIT_TIMEOUT And SRB_Exec.SRB_Hdr.SRB_Status <> SS_COMP Then
            ExecCMDASPI = STATUS_TIMEOUT
        Else
            ExecCMDASPI = SRB_Exec.SRB_TargStat
        End If
    End If

    ' Debugging
    btLastASC = SRB_Exec.SRB_SenseData(12)
    btLastASCQ = SRB_Exec.SRB_SenseData(13)

    CloseHandle hEvent
End Function

















Public Function SPTITrayOpen() As Boolean
    Dim btEvent(8)  As Byte

    Set colDrives = New Collection
    Call FindDrivesSPTI

    If Not CDTestUnitReady() = STATUS_GOOD Then
        If btLastASC = &H3A And btLastASCQ = &H1 Then
            Exit Function
        ElseIf btLastASC = &H3A And btLastASCQ = &H2 Then
            SPTITrayOpen = True
            Exit Function
        End If
    End If

    If CDGetEventStatusNotification(&H10, VarPtr(btEvent(0)), UBound(btEvent) + 1) = STATUS_GOOD Then
        SPTITrayOpen = Abs(CBool(btEvent(5) And 2 ^ 0))
       ' CBool(value And 2 ^ bit)
    End If
End Function

Public Sub FindDrivesSPTI()
    Dim i           As Integer
    Dim strDrive    As String

    For i = 1 To 26
        strDrive = ChrW$(i + 64)
        If GetDriveType(strDrive & ":") = DTYPE_CDROM Then
            colDrives.Add strDrive
        End If
    Next
End Sub


Private Function ExecCMDSPTI(cdb() As Byte, CDBLen As Byte, direction As DataDirection, ByVal buffer _
    As Long, ByVal bufferlen As Long, Optional timeout As Integer = 5) As Status
    Dim lngHandle   As Long
    Dim BytesRet    As Long
    Dim lngStatus   As Long
    Dim SPT         As SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER

    If Not GetDriveHandleSPTI(lngHandle) Then
        ExecCMDSPTI = STATUS_RESERV_CONF
        Exit Function
    End If

    ' Wait For Ever = 3 Stunden (10800s)
    If timeout = 0 Then timeout = 10800

    With SPT.SPT
        .Length = Len(SPT.SPT)
        .TimeOutValue = timeout

        .SenseInfoLength = UBound(SPT.SenseBuffer) - 4
        ' Sense Buffer Offset in der Struktur
        .SenseInfoOffset = Len(SPT.SPT) + 4

        If direction = DIR_IN Then
            .DataIn = SCSI_IOCTL_DATA_IN
        Else
            .DataIn = SCSI_IOCTL_DATA_OUT
        End If

        CopyMemory .cdb(0), cdb(0), CDBLen
        .CdbLength = CDBLen

        .DataBuffer = buffer
        .DataTransferLength = bufferlen
    End With

    ' Command senden
    lngStatus = DeviceIoControl(lngHandle, IOCTL_SCSI_PASS_THROUGH_DIRECT, SPT, Len(SPT), SPT, _
                Len(SPT), BytesRet, ByVal 0&)

    If lngStatus <> 1 Then
        ' grob geraten...
        ExecCMDSPTI = STATUS_TIMEOUT
    Else
        ' Target Status zurckgeben
        ExecCMDSPTI = SPT.SPT.ScsiStatus
    End If

    btLastSK = SPT.SenseBuffer(2)
    btLastASC = SPT.SenseBuffer(12)
    btLastASCQ = SPT.SenseBuffer(13)
End Function

Private Function GetDriveHandleSPTI(ByRef fh As Long) As Boolean
Static Init As Boolean
Dim flags   As Long
Dim i       As Integer

If Not Init Then
    flags = GENERIC_READ
    If IsNT_2K_XP Then flags = flags Or GENERIC_WRITE
       For i = 1 To 26
           ' aktuelles Laufwerk ist CD/DVD?
           If GetDriveType(ChrW$(i + 64) & ":") = DTYPE_CDROM Then
              ' \\.\X: fr Laufwerke
              fh = CreateFile("\\.\" & ChrW$(i + 64) & ":", flags, FILE_SHARE_READ Or FILE_SHARE_WRITE, _
                   ByVal 0&, OPEN_EXISTING, 0, 0)
              ' handle speichern
              lngHandles(i - 1) = fh
           Else
              lngHandles(i - 1) = -1
           End If
       Next
       ' wir haben alle nur mglichen Handles :)
       Init = True
End If

    ' Handle fr gewnschtes Laufwerk zurckgeben
    fh = lngHandles(AscW(UCase$(drvid)) - 65)
    GetDriveHandleSPTI = fh <> -1
End Function













Private Function SRBGetDev(udt As SRB_GetDevType) As Long
    SRBGetDev = CallFunc(FNC_CMD, VarPtr(udt))
End Function

Private Function SRBExec(udt As SRB_ExecuteIO) As Long
    SRBExec = CallFunc(FNC_CMD, VarPtr(udt))
End Function

Private Function SRBSetTimeout(udt As SRB_GetSetTimeouts) As Long
    SRBSetTimeout = CallFunc(FNC_CMD, VarPtr(udt))
End Function

Private Function SRBDiskInfo(udt As SRB_GetDiskInfo) As Long
    SRBDiskInfo = CallFunc(FNC_CMD, VarPtr(udt))
End Function

Private Function LoWord(ByVal DWord As Long) As Long
  LoWord = DWord And &HFFFF&
End Function

Private Function LoByte(ByRef Word As Integer) As Byte
  LoByte = Word And &HFF
End Function

Private Function HiByte(ByRef Word As Integer) As Byte
  HiByte = (Word And &HFF00&) \ &H100
End Function

Public Function IsBitSet(ByVal value As Long, bit As Byte) As Boolean
    IsBitSet = CBool(value And 2 ^ bit)
End Function

Private Sub InitShifting()
    Dim i   As Long
    For i = 0 To 30: lngPower2(i) = 2& ^ i: Next
    lngPower2(31) = &H80000000
End Sub

Private Function IsNT_2K_XP() As Boolean
    Dim sys As OSVERSIONINFOEX

    sys.dwOSVersionInfoSize = Len(sys)
    GetVersionEx sys

    IsNT_2K_XP = sys.dwPlatformId = VER_PLATFORM_WIN32_NT
End Function

Private Function CTL_CODE(ByVal lDevType As Long, ByVal lFunction As Long, ByVal lMethod As Long, ByVal lAccess As Long) As Long
    CTL_CODE = LShift(lDevType, 16) Or LShift(lAccess, 14) Or LShift(lFunction, 2) Or lMethod
End Function

Private Function LShift(ByVal lThis As Long, ByVal lBits As Long) As Long
    Static Init As Boolean

    If Not Init Then InitShifting: Init = True

    If (lBits <= 0) Then
        LShift = lThis
    ElseIf (lBits > 63) Then
        Exit Function
    ElseIf (lBits > 31) Then
        LShift = 0
    Else
        If (lThis And lngPower2(31 - lBits)) = lngPower2(31 - lBits) Then
            LShift = (lThis And (lngPower2(31 - lBits) - 1)) * lngPower2(lBits) Or lngPower2(31)
        Else
            LShift = (lThis And (lngPower2(31 - lBits) - 1)) * lngPower2(lBits)
        End If
    End If
End Function

Public Function CDGetEventStatusNotification(request As Byte, buffer As Long, bufferlen As Integer) As Status
    Dim cdb(9)  As Byte

    cdb(0) = OP_GET_EVENT_STATUS_NOTIFICATION
    cdb(1) = 1
    cdb(4) = request
    cdb(8) = LoByte(bufferlen)
    
    If ASPI = True Then
        CDGetEventStatusNotification = ExecCMDASPI(cdb, 10, DIR_IN, buffer, bufferlen)
    ElseIf SPTI = True Then
        CDGetEventStatusNotification = ExecCMDSPTI(cdb, 10, DIR_IN, buffer, bufferlen)
    End If
End Function

Public Function CDTestUnitReady() As Status
    Dim cdb(5)  As Byte
    
    cdb(0) = OP_TEST_UNIT_READY     ' fast sinnlos ;)
    
    If ASPI = True Then
        CDTestUnitReady = ExecCMDASPI(cdb, 6, DIR_IN, 0, 0)
    ElseIf SPTI = True Then
        CDTestUnitReady = ExecCMDSPTI(cdb, 6, DIR_IN, 0, 0)
    End If
End Function

Public Function CDModeSense10(pc As Byte, buffer As Long, bufferlen As Integer) As Status
Dim cdb(9)  As Byte

    cdb(0) = OP_MODE_SENSE10        ' MODE SENSE10 OpCode
    cdb(1) = &H8                    ' DBD (Disable Block Descriptors)
    cdb(2) = pc Or &H80             ' &H80 = default values
    cdb(7) = HiByte(bufferlen)      ' Datenzuweisungslnge MSB
    cdb(8) = LoByte(bufferlen)      ' Datenzuweisungslnge LSB

    
    If ASPI = True Then
        CDModeSense10 = ExecCMDASPI(cdb, 10, DIR_IN, buffer, bufferlen)
    ElseIf SPTI = True Then
        CDModeSense10 = ExecCMDSPTI(cdb, 10, DIR_IN, buffer, bufferlen)
    End If
End Function


Private Function LoadingMech(ByVal Bt As Byte) As String
    Select Case Bt
        Case 0: LoadingMech = "Caddy"
        Case 1: LoadingMech = "Tray"
        Case 2: LoadingMech = "Popup"
        Case 4: LoadingMech = "CD Wechsler"
        Case 5: LoadingMech = "CD Wechsler mit Magazin"
        Case 3, 6, 7: LoadingMech = "unbekannt"
    End Select
End Function

Public Function SHR(ByVal lThis As Long, ByVal lBits As Long) As Long
    Static Init As Boolean

    If Not Init Then InitShifting: Init = True

    If (lBits <= 0) Then
        SHR = lThis
    ElseIf (lBits > 63) Then
        Exit Function
    ElseIf (lBits > 31) Then
        SHR = 0
    Else
        If (lThis And lngPower2(31)) = lngPower2(31) Then
            SHR = (lThis And &H7FFFFFFF) \ lngPower2(lBits) Or lngPower2(31 - lBits)
        Else
            SHR = lThis \ lngPower2(lBits)
        End If
    End If

End Function





Public Function CallFunc(ByVal sFunction As String, ParamArray ParmLongs() As Variant) As Long
  Dim i As Long
  Dim j As Long
  
  'Check that the DLL is loaded
  If hMod = 0 Then
    
    'If in the IDE just stop, programmer may have On Error Resume Next protection and miss the problem.
    Debug.Assert False
    Call Err.Raise(ERR_NUM + 0, ERR_SRC, "DLL not loaded")
  End If

  'Check to see if we're calling the same cdecl function as the previous call to CallFunc
  If (StrComp(sLastFunc, sFunction) <> 0) Or bNewDLL Then
    
    'Get the address of the function
    nAddr = GetProcAddress(hMod, sFunction)
    If nAddr = 0 Then
      
      'If in the IDE just stop, programmer may have On Error Resume Next protection and miss the problem.
      Debug.Assert False
      Call Err.Raise(ERR_NUM + 1, ERR_SRC, "Failed to locate function: " & sFunction)
    End If

    'Patch the code buffer to call the relative address to the cdecl function
    Call RtlMoveMemory(ByVal pCode + PATCH_01, nAddr - pCode - (PATCH_01 + 4), 4)
    bNewDLL = False
    sLastFunc = sFunction
  End If
  
  With pb
    j = UBound(ParmLongs)
    If j >= MAX_ARG Then
      
      'If in the IDE just stop, programmer may have On Error Resume Next protection and miss the problem.
      Debug.Assert False
      Call Err.Raise(ERR_NUM + 2, ERR_SRC, "Too many parameters")
    End If
    
    'Fill the parameter block
    For i = 0 To j
      .Params(i) = ParmLongs(i)
    Next i
    
    .ParamCount = i                                         '(j + 1)
  End With
  
  Call SetLastError(0)                                      'Clear the error code
  CallFunc = ASPILib.z_DO_NOT_CALL(VarPtr(pb))                      'Execute the code buffer passing the address of the parameter block
End Function

Public Sub Redirect(ByVal sHexCode As String, ByVal bPatch As Boolean)
  Dim i     As Long
  Dim nLen  As Long
  Dim s     As String
  
  nLen = Len(sHexCode)
  
  For i = 1 To nLen Step 2
    s = s & ChrB$(Val("&H" & Mid$(sHexCode, i, 2)))
  Next i
  
  ReDim Preserve sCode(0 To nEntry)
  sCode(nEntry) = s
  
  If bPatch Then
    'Patch the vtable entry to point to the code
    Call RtlMoveMemory(ByVal pMe + &H1C + (nEntry * 4), StrPtr(sCode(nEntry)), 4)
  End If
  
  nEntry = nEntry + 1                               'In case another patch is added to the class
End Sub





Public Function DllLoad(ByVal sName As String) As Boolean
  hMod = LoadLibraryA(sName)

  If hMod <> 0 Then
    DllLoad = True
    bNewDLL = True
  End If
End Function

Public Function DllUnload() As Boolean
  If hMod <> 0 Then
    DllUnload = (FreeLibrary(hMod) <> 0)
    hMod = 0
  End If
End Function


